unit plChgCompo;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, TypInfo;

function ChangeComponent(Original: TComponent; NewClass: TComponentClass):
  TComponent;

implementation

//=============================================================================
//  R|[lg֐
//  Original̃R|[lgNewClassŎw肷NX^̃R|[lgƓ
//  @\R|[lgɂ
//  NewClass͕WVCL̃NXhĂNX

//  R|[lgCXg[Ɏg@]
//  http://delfusa.main.jp/delfusafloor/technic/technic/024_ChangeComponent.html
//
//  usesTypInfoKv
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3) + Delphi 2010, XE Pro
//  Windows 7 U64 + Delphi 2010, XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
function ChangeComponent(Original: TComponent; NewClass: TComponentClass):
  TComponent;
var
  APropList   : TPropList;
  New         : TComponent;
  Stream      : TStream;
  Methods     : array of TMethod;
  MethodCount : Integer;
  i           : Integer;
begin
  MethodCount := GetPropList(Original.ClassInfo, [tkMethod], @APropList[0]);
  SetLength(Methods, MethodCount);

  for i := 0 to MethodCount - 1 do begin
    Methods[i] := GetMethodProp(Original, APropList[i]);
  end;

  Stream := TMemoryStream.Create;
  try
    Stream.WriteComponent(Original);
    New := NewClass.Create(Original.Owner);
    if New is TControl then TControl(New).Parent := TControl(Original).Parent;
    Original.Free;
    Stream.Position := 0;
    Stream.ReadComponent(New);
  finally
    Stream.free
  end;

  for i := 0 to MethodCount - 1 do begin
    SetMethodProp(New, APropList[i], Methods[i]);
  end;
  Result := New;
end;

end.
